/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.13X */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <process.h>
#include <sys/kernel.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"


#define APRESSED	21
#define BPRESSED	22
#define	CPRESSED	23
#define DPRESSED	24

#define LEFT		11
#define RIGHT		12
#define UP			13
#define DOWN		14

#define ULEFT		15
#define URIGHT		16
#define DLEFT		17
#define DRIGHT		18

#define	BSET		1
#define BUNSET		0

/* Application Options string */
const char ApOptions[] =
	AB_OPTIONS ""; /* Add your options in the "" */

int msg_handler(void *client_data, pid_t pid, void *msg, size_t msglen);

int
init_fun( int argc, char *argv[] )
	{
	int rv;

	PtAppAddInput( NULL, 0, msg_handler, NULL );
	rv = spawnl( P_NOWAIT, "joydrv", "", NULL, NULL, NULL );	
	if (rv==-1)
		perror("spawnl");


	/* eliminate 'unreferenced' warnings */
	argc = argc, argv = argv;

	return( Pt_CONTINUE );

	}

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\*/

int setup_fun( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\*/

int msg_handler(void *client_data, pid_t pid, void *msg, size_t msglen)
{
int val, but;
int l=0, r=0, u=0, d=0, ab=0, bb=0, cb=0, db=0;
static int ll=0, lr=0, lu=0, ld=0, lab=0, lbb=0, lcb=0, ldb=0;
struct msg_s        {
	unsigned char msg[30];
} *themsg;

themsg = ( struct msg_s * ) msg;		// Do I need this line?

Reply(pid, &msg, msglen);

val = themsg->msg[0];
ab = themsg->msg[1];
bb = themsg->msg[2];
cb = themsg->msg[3];
db = themsg->msg[4];

switch( val ) {
	case LEFT:
		l=1;
		break;
	case RIGHT:
		r=1;
		break;
	case UP:
		u=1;
		break;
	case DOWN:
		d=1;
		break;
	case DLEFT:
		l=1;	d=1;
		break;
	case DRIGHT:
		r=1;	d=1;
		break;
	case ULEFT:
		l=1;	u=1;
		break;
	case URIGHT:
		r=1;	u=1;
		break;
	default:
		l=0;r=0;u=0;d=0;
	}

CheckDo( ABW_left,    l, ll  );
CheckDo( ABW_right,   r, lr  );
CheckDo( ABW_up,      u, lu  );
CheckDo( ABW_down,    d, ld  );
CheckDo( ABW_red,    ab, lab );
CheckDo( ABW_blue,   bb, lbb );
CheckDo( ABW_yellow, cb, lcb );
CheckDo( ABW_green,  db, ldb );	

ll=l; lr=r; lu=u; ld=d; lab=ab; lbb=bb; lcb=cb; ldb=db;

return(Pt_CONTINUE);
}

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\*/

void CheckDo( PtWidget_t *widget, int new, int old )
{
	if (new!=old)
	{
		if (new)		// Set it		
			widgetset( widget, BSET );
		else		// unset it.	
			widgetset( widget, BUNSET );
	}
}

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\*/

void widgetset( PtWidget_t *widget, int state )
{
PtArg_t args[1];

if (state==BSET)
	PtSetArg( &args[0], Pt_ARG_FLAGS, Pt_SET | Pt_HIGHLIGHTED, Pt_SET | Pt_HIGHLIGHTED );
else
	PtSetArg( &args[0], Pt_ARG_FLAGS, Pt_HIGHLIGHTED, Pt_SET | Pt_HIGHLIGHTED );
PtSetResources( widget, 1, args );

}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\*/
 

