#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <sys/sched.h>
#include <sys/kernel.h>

/**** Defines Section ****/
#define JPORT		0x201
#define CMAX		700
#define JITTERVAL	5
#define BIGJITTERVAL 200
#define DEFAULTMAXX	800
#define DEFAULTMINX	0
#define TRUE		1
#define FALSE		0

#define APRESSED	21
#define BPRESSED	22
#define	CPRESSED	23
#define DPRESSED	24

#define LEFT		11
#define RIGHT		12
#define UP			13
#define DOWN		14

#define ULEFT		15
#define URIGHT		16
#define DLEFT		17
#define DRIGHT		18


/*************************/

/**** Globals Section ****/
int XRef, YRef;			// The initial values of X and Y


/*************************/

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
void main(int argc, char *argv[])
{
int a,b,c,d;
int returnval, returnval2; 
int parentpid;
char done=0;
int counter;
pid_t serverpid;
unsigned char msg[20];
unsigned char rmsg[20];

XRef = GetX();			// Set the initial values of X & Y
YRef = GetY();

serverpid = getppid();			// Get the pid of whoever invoked us.

setprio(0,3);       // priority setting

while(!done)
{
returnval = pad_is_active();
returnval2 = pad_is_active();

a = APressed();
b = BPressed();
c = CPressed();
d = DPressed();


if ((returnval)&&(returnval==returnval2)) 
	{
		msg[0] = returnval;
		msg[1] = a;
		msg[2] = b;
		msg[3] = c;
		msg[4] = d;

		if (argc==1) {
			if ( Send(serverpid,msg,rmsg,sizeof(msg),sizeof(rmsg))==-1 ) 
				exit(0);		// Nobody home, or error, so die
		}else
			dumpthis( returnval, ButtonPressed() );
		for (counter=0;counter<65000;counter++);		// cheap wait
	}
else
if ( (!returnval)&&(!returnval2) )
	{
		msg[0] = returnval;
		msg[1] = a;
		msg[2] = b;
		msg[3] = c;
		msg[4] = d;
		if (argc==1) {
			if ( Send(serverpid,msg,rmsg,sizeof(msg),sizeof(rmsg))==-1 ) 
				exit(0);		// Nobody home, or error, so die
		}else
			dumpthis( returnval, ButtonPressed() );
		for (counter=0;counter<65000;counter++);		// cheap wait
	}
}//end while

exit(0);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
void dumpthis( int rv, int but )
{

switch( rv ) {
	case LEFT:
		printf("Left\n");
		break;
	case RIGHT:
		printf("Right\n");
		break;
	case UP:
		printf("Up\n");
		break;
	case DOWN:
		printf("Down\n");
		break;
	case DLEFT:
		printf("Down-Left\n");
		break;
	case DRIGHT:
		printf("Down-Right\n");
		break;
	case ULEFT:
		printf("Up-Left\n");
		break;
	case URIGHT:
		printf("Up-Right\n");
		break;
	}

switch( but ) {
	case APRESSED:
		printf("A\n");
		break;
	case BPRESSED:
		printf("B\n");
		break;
	case CPRESSED:
		printf("C\n");
		break;
	case DPRESSED:
		printf("D\n");
		break;
	}

}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int pad_is_active(void)
{
int xstat=XRef, ystat=YRef;
int statex=0, statey=0;

xstat = GetX();

if ( (xstat<(XRef-BIGJITTERVAL)) && ((GetX())<(XRef-BIGJITTERVAL)) )
	statex = LEFT;
else
if ( (xstat>(XRef+BIGJITTERVAL)) && ((GetX())>(XRef+BIGJITTERVAL)) )
	statex = RIGHT;

ystat = GetY();

if ( (ystat<(YRef-BIGJITTERVAL)) && ((GetY())<(YRef-BIGJITTERVAL)) )
	statey = UP;
else
if ( (ystat>(YRef+BIGJITTERVAL)) && ((GetY())>(YRef+BIGJITTERVAL)) )
	statey = DOWN;

if ((!statex)&&(!statey))
	return(0);
else
if ((statex)&&(!statey))
	return( statex );
else
if ((!statex)&&(statey))
	return( statey );
else	// 'tis a diagonal
{
	if ((statex == LEFT) && (statey == UP))
		return( ULEFT );
	else
	if ((statex == RIGHT)&& (statey == UP))
		return( URIGHT );
	else
	if ((statex == LEFT) && (statey == DOWN))
		return( DLEFT );
	else
	if ((statex == RIGHT)&& (statey == DOWN))
		return( DRIGHT);
	else
		return(0);
}


}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/

/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
void GetJoystickData(int v[4], char b[4])
{
int i, j;
int mask=15;

outp(JPORT, 0);
for (i=1;mask && i<CMAX;i++)
{
	j = inp(JPORT) ^ mask;
	if (j & 1)	{ v[0] = i; mask ^= 1; }
	if (j & 2)	{ v[1] = i; mask ^= 2; }
	if (j & 4)  { v[2] = i; mask ^= 4; }
	if (j & 8)	{ v[3] = i; mask ^= 8; }
}// End for
j = inp(JPORT);
b[0] = !(j & 0x10);
b[1] = !(j & 0x20);
b[2] = !(j & 0x40);
b[3] = !(j & 0x80);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int GetX(void)
{
int v[4];
char b[4];
GetJoystickData(v, b);
return(v[0]);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int GetY(void)
{
int v[4];
char b[4];
GetJoystickData(v, b);
return(v[1]);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int ButtonPressed(void)
{
int a=0,b=0,c=0,d=0,j;

outp(JPORT, 0);
j = inp(JPORT);
a = !(j & 0x10);
b = !(j & 0x20);
c = !(j & 0x40);
d = !(j & 0x80);

if (a)	return (APRESSED);
else if (b)  return (BPRESSED);
else if (c)  return (CPRESSED);
else if (d)  return (DPRESSED);
else
	return(FALSE);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int APressed(void)
{
int a=0,j;

outp(JPORT, 0);
j = inp(JPORT);
a = !(j & 0x10);

if (a)
	return (1);
else
	return(0);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int BPressed(void)
{
int b=0,j;

outp(JPORT, 0);
j = inp(JPORT);
b = !(j & 0x20);

if (b)
	return (1);
else
	return(0);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int CPressed(void)
{
int c=0,j;

outp(JPORT, 0);
j = inp(JPORT);
c = !(j & 0x40);

if (c)
	return (1);
else
	return(0);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
int DPressed(void)
{
int d=0,j;

outp(JPORT, 0);
j = inp(JPORT);
d = !(j & 0x80);

if (d)
	return (1);
else
	return(0);
}
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/




/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/
/*//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//*/

